diff --git a/contrib/ivshmem-client/ivshmem-client.h b/contrib/ivshmem-client/ivshmem-client.h
index fc45a38060..9b0b24ce69 100644
--- a/contrib/ivshmem-client/ivshmem-client.h
+++ b/contrib/ivshmem-client/ivshmem-client.h
@@ -22,7 +22,7 @@
 #include <sys/select.h>
 
 #include "qemu/queue.h"
-#include "hw/misc/ivshmem.h"
+#include "hw/misc/ivshmem-pci.h"
 
 /**
  * Maximum number of notification vectors supported by the client
diff --git a/contrib/ivshmem-server/ivshmem-server.h b/contrib/ivshmem-server/ivshmem-server.h
index d870adb6a0..a8c1a6d5fb 100644
--- a/contrib/ivshmem-server/ivshmem-server.h
+++ b/contrib/ivshmem-server/ivshmem-server.h
@@ -30,7 +30,7 @@
 
 #include "qemu/event_notifier.h"
 #include "qemu/queue.h"
-#include "hw/misc/ivshmem.h"
+#include "hw/misc/ivshmem-pci.h"
 
 /**
  * Maximum number of notification vectors supported by the server
diff --git a/docs/system/device-emulation.rst b/docs/system/device-emulation.rst
index a1b0d7997e..137371eaf7 100644
--- a/docs/system/device-emulation.rst
+++ b/docs/system/device-emulation.rst
@@ -85,7 +85,7 @@ Emulated Devices
    devices/can.rst
    devices/ccid.rst
    devices/cxl.rst
-   devices/ivshmem.rst
+   devices/ivshmem-pci.rst
    devices/ivshmem-flat.rst
    devices/keyboard.rst
    devices/net.rst
diff --git a/docs/system/devices/ivshmem-flat.rst b/docs/system/devices/ivshmem-flat.rst
index 1f97052804..ccdceef171 100644
--- a/docs/system/devices/ivshmem-flat.rst
+++ b/docs/system/devices/ivshmem-flat.rst
@@ -17,7 +17,7 @@ running Linux), and an arm VM (using the ivshmem-flat device and running Zephyr
 instead).
 
 The ivshmem-flat device does not support the use of a ``memdev`` option (see
-ivshmem.rst for more details). It relies on the ivshmem server to create and
+ivshmem-pci.rst for more details). It relies on the ivshmem server to create and
 distribute the proper shared memory file descriptor and the eventfd(s) to notify
 (interrupt) the peers. Therefore, to use this device, it is always necessary to
 have an ivshmem server up and running for proper device creation.
diff --git a/docs/system/devices/ivshmem.rst b/docs/system/devices/ivshmem-pci.rst
similarity index 96%
rename from docs/system/devices/ivshmem.rst
rename to docs/system/devices/ivshmem-pci.rst
index ce71e25663..4cd434e2db 100644
--- a/docs/system/devices/ivshmem.rst
+++ b/docs/system/devices/ivshmem-pci.rst
@@ -1,5 +1,5 @@
-Inter-VM Shared Memory device
------------------------------
+Inter-VM Shared Memory PCI device
+---------------------------------
 
 On Linux hosts, a shared memory device is available. The basic syntax
 is:
diff --git a/hw/misc/Kconfig b/hw/misc/Kconfig
index 8f9ce2f68c..366c7e295f 100644
--- a/hw/misc/Kconfig
+++ b/hw/misc/Kconfig
@@ -67,12 +67,12 @@ config MACIO
     select MAC_NVRAM
     select MOS6522
 
-config IVSHMEM_DEVICE
+config IVSHMEM_PCI
     bool
     default y if PCI_DEVICES
     depends on PCI && LINUX && IVSHMEM && MSI_NONBROKEN
 
-config IVSHMEM_FLAT_DEVICE
+config IVSHMEM_FLAT
     bool
     default y
     depends on LINUX && IVSHMEM
diff --git a/hw/misc/ivshmem-pci.c b/hw/misc/ivshmem-pci.c
index 900d523334..8f9cd94f42 100644
--- a/hw/misc/ivshmem-pci.c
+++ b/hw/misc/ivshmem-pci.c
@@ -37,7 +37,7 @@
 #include "system/hostmem.h"
 #include "qapi/visitor.h"
 
-#include "hw/misc/ivshmem.h"
+#include "hw/misc/ivshmem-pci.h"
 #include "qom/object.h"
 
 #define PCI_VENDOR_ID_IVSHMEM   PCI_VENDOR_ID_REDHAT_QUMRANET
diff --git a/hw/misc/meson.build b/hw/misc/meson.build
index 55f493521b..0459820332 100644
--- a/hw/misc/meson.build
+++ b/hw/misc/meson.build
@@ -38,8 +38,8 @@ system_ss.add(when: 'CONFIG_SIFIVE_U_PRCI', if_true: files('sifive_u_prci.c'))
 subdir('macio')
 
 # ivshmem devices
-system_ss.add(when: 'CONFIG_IVSHMEM_DEVICE', if_true: files('ivshmem-pci.c'))
-system_ss.add(when: 'CONFIG_IVSHMEM_FLAT_DEVICE', if_true: files('ivshmem-flat.c'))
+system_ss.add(when: 'CONFIG_IVSHMEM_PCI', if_true: files('ivshmem-pci.c'))
+system_ss.add(when: 'CONFIG_IVSHMEM_FLAT', if_true: files('ivshmem-flat.c'))
 
 system_ss.add(when: 'CONFIG_ALLWINNER_SRAMC', if_true: files('allwinner-sramc.c'))
 system_ss.add(when: 'CONFIG_ALLWINNER_A10_CCM', if_true: files('allwinner-a10-ccm.c'))
diff --git a/include/hw/misc/ivshmem.h b/include/hw/misc/ivshmem-pci.h
similarity index 88%
rename from include/hw/misc/ivshmem.h
rename to include/hw/misc/ivshmem-pci.h
index 433ef53d79..c00b39c0cd 100644
--- a/include/hw/misc/ivshmem.h
+++ b/include/hw/misc/ivshmem-pci.h
@@ -17,9 +17,9 @@
  * Contributions after 2012-01-13 are licensed under the terms of the
  * GNU GPL, version 2 or (at your option) any later version.
  */
-#ifndef IVSHMEM_H
-#define IVSHMEM_H
+#ifndef IVSHMEM_PCI_H
+#define IVSHMEM_PCI_H
 
 #define IVSHMEM_PROTOCOL_VERSION 0
 
-#endif /* IVSHMEM_H */
+#endif /* IVSHMEM_PCI_H */
diff --git a/tests/qtest/meson.build b/tests/qtest/meson.build
index 94b28e5a53..80f15185ca 100644
--- a/tests/qtest/meson.build
+++ b/tests/qtest/meson.build
@@ -37,7 +37,7 @@ endif
 
 qtests_pci = \
   (config_all_devices.has_key('CONFIG_VGA') ? ['display-vga-test'] : []) +                  \
-  (config_all_devices.has_key('CONFIG_IVSHMEM_DEVICE') ? ['ivshmem-test'] : [])
+  (config_all_devices.has_key('CONFIG_IVSHMEM_PCI') ? ['ivshmem-test'] : [])
 
 qtests_cxl = \
   (config_all_devices.has_key('CONFIG_CXL') ? ['cxl-test'] : [])